<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>Bronapp</title>
    <link rel="stylesheet" href="css/bootstrap.min.css" />
    <link rel="stylesheet" href="css/jquery-ui.min.css" />
    <link rel="stylesheet" href="css/jquery.datetimepicker.min.css" />
    <link rel="stylesheet" href="css/bronapp.css" />
</head>

<body>

    <!-- Container -->
    <div class="container">
        <img src="static/logo.jpg" style="padding-top: 30px; padding-bottom: 30px;" />
        <ul class="nav nav-pills mb-3 bg-success">
            <li class="nav-item">
                <a class="nav-link active bg-success" id="doctors-tab" data-toggle="pill" href="#doctors" role="tab" aria-controls="doctors" aria-selected="true">Doctors</a>
            </li>

            <li class="nav-item dropdown">
                <a id="user-name" class="btn btn-success dropdown-toggle" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">Unknown</a>
                <div class="dropdown-menu">
                    <a class="dropdown-item" href="/bronapp/logout">Logout</a>
                </div>
            </li>
        </ul>

        <div class="tab-content" style="padding-bottom: 30px;">
            <div id="doctors" class="tab-pane fade show active" role="tabpanel" aria-labelledby="doctors-tab">
                <table class="table table-sm table-hover">
                    <thead>
                    <th scope="col">ID</th>
                    <th scope="col">Doctor</th>
                    <th scope="col">Appointment</th>
                    <th scope="col">Patient</th>
                    <th scope="col">Patient phone</th>
                    <th scope="col">Comment</th>
                    <th></th>
                    <tr class="bg-success"></tr>
                    </thead>
                    <tbody id="doctor_list"></tbody>
                </table>
                <button type="button" class="btn btn-success" onclick="prepareDoctorAdd()">Add</button>
            </div>

            <div id="booking" class="tab-pane fade" role="tabpanel" aria-labelledby="booking-tab">
                Book an appointment here:
                <button type="button" class="btn btn-success" onclick="prepareDoctorAdd()">Book</button>
            </div>
        </div>
    </div>

    <!-- Modal -->
    <div class="modal fade" id="doctor_modal" tabindex="-1" role="dialog" aria-labelledby="doctor_modal_label" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="doctor_modal_label">Add/Edit Patient info</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">x</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form name="doctorForm">
                        <input type="hidden" name="id" id="id" value="0" />
                        <input type="text" id="doctorname" name="doctorname" class="form-control" placeholder="Doctor" /><br />
                        <input type="text" id="date" name="date" readonly="readonly" class="form-control" placeholder="Appointment" /><br />
                        <input type="text" id="customername" name="customername" class="form-control" placeholder="Patient" /><br />
                        <input type="text" id="phone" name="phone" class="form-control" placeholder="Patient phone" /><br />
                        <input type="text" id="comment" name="comment" class="form-control" placeholder="Comment" />
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                    <button type="button" class="btn btn-success" onclick="saveDoctor();" data-dismiss="modal">Confirm</button>
                </div>
            </div>
        </div>
    </div>


    <script src="js/jquery.min.js"></script>
    <script src="js/jquery-ui.min.js"></script>
    <script src="js/jquery.datetimepicker.full.min.js"></script>
    <script src="js/popper.min.js"></script>
    <script src="js/bootstrap.min.js"></script>

    <script>

        $(document).ready(
            function() {
                initUIControls();
                // kutsun välja resti teenuse funktsiooni
                giveMeUser();
                giveMeAllDoctors();
            }
        );

        function initUIControls() {
            $('#date').datetimepicker(
                {
                    format: 'd.m.Y H:i',
                    step: 30,
                    mask: true
                }
            );
        }
        function giveMeUser() {
            $.ajax(
                {
                    method: "GET",
                    url: "/bronapp/user",
                    dataType: "json",
                    contentType: "application/json",
                    complete: function (response) {
                        if (response.status == '401') {
                            window.location.href = '/bronapp/login';
                        }
                        var user = response.responseJSON;
                        $('#user-name').html(user.name);
                    }
                }
            );
        }

        function giveMeAllDoctors() {
            $.ajax(
                {
                    method: "GET",
                    url: "/bronapp/doctor/list",
                    dataType: "json",
                    contentType: "application/json",
                    complete: function (response) {
                    if (response.status == '401') {
                           window.location.href = '/bronapp/login';
                       }
                        $('#doctor_list').empty();
                        var doctors = response.responseJSON;
                        for (var i = 0; i < doctors.length; i++) {
                            var row = "<tr>";
                            row = row + "<td>" + doctors[i].id + "</td>";
                            row = row + "<td>" + doctors[i].doctorname + "</td>";
                            row = row + "<td>" + doctors[i].date + "</td>";
                            row = row + "<td>" + doctors[i].customername + "</td>";
                            row = row + "<td>" + doctors[i].phone + "</td>";
                            row = row + "<td>" + doctors[i].comment + "</td>";
                            row = row + "<td>";
                            <!--for (var j = 0; j < doctors[i].accounts.length; j++) {-->
                                <!--row = row + customers[i].accounts[j].accountNumber + "<br />";-->
                            <!--}-->
                            row = row + "</td>";
                            row = row + '<td><button class="btn btn-sm btn-success" onClick="prepareDoctor('
                                + doctors[i].id + ');">Edit</button>&nbsp;'
                                + '<button class="btn btn-sm btn-warning" onClick="deleteDoctor('
                                + doctors[i].id + ');">Delete</button></td>';
                            row = row + "</tr>";
                            $('#doctor_list').append(row);
                        }
                    }
                }
            );
        }

        function prepareDoctor(doctorId) {
            $.ajax(
                {
                    method: "GET",
                    url: "/bronapp/doctor/get/" + doctorId,
                    dataType: "json",
                    contentType: "application/json",
                    complete: function (response) {
                        var doctor = response.responseJSON;
                        $('#id').val(doctor.id);
                        $('#doctorname').val(doctor.doctorname);
                        $('#date').val(doctor.date);
                        $('#customername').val(doctor.customername);
                        $('#phone').val(doctor.phone);
                        $('#comment').val(doctor.comment);
                        $('#doctor_modal').modal('show');
                    }
                }
            );
        }

        function prepareDoctorAdd() {
            $('#id').val(0);
            $('#doctorname').val("");
            $('#date').val("");
            $('#customername').val("");
            $('#phone').val("");
            $('#comment').val("");
            $('#doctor_modal').modal('show');
        }

        function saveDoctor() {
            var url = "";
            if ($('#id').val() > 0) {
                url = "/bronapp/doctor/save";
            } else {
                url = "/bronapp/doctor/add";
            }
            $.ajax(
                {
                    method: "POST",
                    url: url,
                    dataType: "json",
                    contentType: "application/json",
                    data: JSON.stringify(getData($('form[name=doctorForm]').serializeArray())),
                    complete: function (response) {
                        giveMeAllDoctors();
                    }
                }
            );
        }

        function getData(data) {
            var result = {};
            $.map(data, function(n) {
                result[n['name']] = n['value'];
            });
            return result;
        }

        function deleteDoctor(doctorId) {
            if (confirm("Are you sure you would like to delete the appointment?")) {
                $.ajax(
                    {
                        method: "POST",
                        url: "/bronapp/doctor/delete/" + doctorId,
                        dataType: "json",
                        contentType: "application/json",
                        complete: function (response) {
                            giveMeAllDoctors();
                        }
                    }
                );
            }
        }

    </script>

</body>

</html>